#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <cstrike>
#include <sdkhooks>
#include <vip_core>

public Plugin:myinfo =
{
	name = "[VIP] CT C4",
	author = "R1KO (skype: vova.andrienko1)",
	version = "1.0"
};

new bool:g_bEnabled;

new bool:g_bHasC4[MAXPLAYERS+1];
new Float:g_fDelay[MAXPLAYERS+1];

static const String:g_sFeature[] = "CT_C4";

public OnPluginStart()
{
	if(VIP_IsVIPLoaded())
	{
		VIP_OnVIPLoaded();
	}
}

public OnPluginEnd() 
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
	{
		VIP_UnregisterFeature(g_sFeature);
	}
}

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(g_sFeature, BOOL, _, OnToggleItem);
}

public Action:OnToggleItem(iClient, const String:sFeatureName[], VIP_ToggleState:OldStatus, &VIP_ToggleState:NewStatus)
{
	if(NewStatus != ENABLED)
	{
		if(IsPlayerAlive(iClient) && GetClientTeam(iClient) == 3)
		{
			new iWeapon = GetPlayerWeaponSlot(iClient, CS_SLOT_C4);
			if(iWeapon != -1)
			{
				CS_DropWeapon(iClient, iWeapon, true, false);
				g_bHasC4[iClient] = false;
			}
		}
	}

	return Plugin_Continue;
}

public OnMapStart()
{
	g_bEnabled = (FindEntityByClassname(-1, "func_bomb_target") != -1);
	
	if(g_bEnabled)
	{
		HookEvent("bomb_dropped", Event_BombDroppedPre, EventHookMode_Pre);
	}
}

public OnMapEnd()
{
	if(g_bEnabled)
	{
		UnhookEvent("bomb_dropped", Event_BombDroppedPre, EventHookMode_Pre);
	}
}

public Event_BombDroppedPre(Handle:hEvent, const String:sEvName[], bool:bDontBroadcast)
{
	new iClient = GetClientOfUserId(GetEventInt(hEvent, "userid"));
	
	if(iClient && VIP_IsClientVIP(iClient) && VIP_IsClientFeatureUse(iClient, g_sFeature))
	{
		new iWeapon = GetEntPropEnt(iClient, Prop_Send, "m_hActiveWeapon");
		if(iWeapon > 0)
		{
			decl String:sClassName[12];
			GetEdictClassname(iWeapon, sClassName, sizeof(sClassName));
			if(strcmp(sClassName[7], "c4") == 0)
			{
				g_fDelay[iClient] = GetGameTime()+1.0;
				SDKHook(iWeapon, SDKHook_StartTouchPost, Hook_StartTouchPost);
			}
		}
	}
}

public Hook_StartTouchPost(iEntity, iClient)
{
	if (iClient > 0 && iClient <= MaxClients && !IsFakeClient(iClient) && IsPlayerAlive(iClient) && GetClientTeam(iClient) == CS_TEAM_CT && 
	g_fDelay[iClient] < GetGameTime() && VIP_IsClientVIP(iClient) && VIP_IsClientFeatureUse(iClient, g_sFeature))
	{	
		SetEntProp(iClient, Prop_Send, "m_iTeamNum", 2);
		RemoveEdict(iEntity);
		GivePlayerItem(iClient, "weapon_c4");
		SetEntProp(iClient, Prop_Send, "m_iTeamNum", 3);
		g_bHasC4[iClient] = true;
	}
}

public Action:CS_OnCSWeaponDrop(iClient, iWeapon)
{
	if(GetClientTeam(iClient) == CS_TEAM_CT)
	{
		decl String:sClassName[12];
		GetEdictClassname(iWeapon, sClassName, sizeof(sClassName));
		if(strcmp(sClassName[7], "c4") == 0)
		{
			g_bHasC4[iClient] = false;
		}
	}

	return Plugin_Continue;
}

public OnClientDisconnect(iClient)
{
	g_bHasC4[iClient] = false;
}

public Action:OnPlayerRunCmd(iClient, &iButtons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
	if (g_bEnabled && g_bHasC4[iClient] && IsPlayerAlive(iClient))
	{
		if (iButtons & IN_ATTACK)
		{
			new iWeapon = GetEntPropEnt(iClient, Prop_Send, "m_hActiveWeapon");
			if(iWeapon > 0)
			{
				decl String:sClassName[12];
				GetEdictClassname(iWeapon, sClassName, sizeof(sClassName));
				if(strcmp(sClassName[7], "c4") == 0)
				{
					iButtons &= ~IN_ATTACK;
					return Plugin_Changed;
				}
			}
		}
	}

	return Plugin_Continue;
}